/*
 * Browser.java
 *
 * Created on March 15, 2003, 5:42 PM
 */

/**
 *
 * @author  rod
 */
import javax.swing.*;
import javax.swing.event.*;
import java.awt.event.*;
import java.awt.*;
import java.util.*;
import dataWrangler.*;

public class Browser extends JFrame implements ActionListener {
    
    Vector thingCollection; // our 'things' which will be a Vector of annotatedThing's (see below)
    int focused; // identifies thing with focus
    public MousePanel drawPanel;
    sbb myControl;
    
    /** Creates a new instance of Browser */
    public Browser(sbb b, Vector v) {
        Rectangle virtualBounds = new Rectangle();
        GraphicsEnvironment ge = GraphicsEnvironment.
        getLocalGraphicsEnvironment();
        GraphicsDevice[] gs =
        ge.getScreenDevices();
        for (int j = 0; j < gs.length; j++) {
            GraphicsDevice gd = gs[j];
            GraphicsConfiguration[] gc =
            gd.getConfigurations();
            for (int i=0; i < gc.length; i++) {
                virtualBounds = virtualBounds.union(gc[i].getBounds());
            }
        }
        this.setLocation((int)(virtualBounds.getMaxX()-450), (int)(virtualBounds.getHeight()/4));
        
        myControl = b;
        thingCollection = annotate(v);
        focused = 0;
        setTitle("Browser");
        addWindowListener(new WindowAdapter() {
            public void windowClosing(WindowEvent e){
                dispose();
            }
        });
        Container contentPane = getContentPane();
        setVisible(true);
        setResizable(true);
        initComponents();
        setSize(400,400);
    }
    
    private Vector annotate(Vector v){
        thingCollection = new Vector();
        for (int i = 0; i < v.size(); i++){
            Thing t = (Thing)(v.elementAt(i));
            thingCollection.addElement(new annotatedThing(t, 0, 0, 0, false, false, false, false));
        }
        return thingCollection;
    }
    
    private void initComponents(){
        Container contentPane = getContentPane();
        JPanel panel, subPanel;
        /*-----------------*/
        panel = new JPanel();
        panel.setLayout(new BorderLayout());
        
        //CLEAR PATH
        subPanel = new JPanel();
        subPanel.setLayout(new FlowLayout(FlowLayout.LEFT));
        JButton clearPath = new JButton("Clear Path");
        clearPath.setActionCommand("CLEARPATH");
        clearPath.addActionListener(this);
        subPanel.add(clearPath);
        //panel.add(subPanel, BorderLayout.NORTH);
        JButton backButton = new JButton("Back");
        backButton.setActionCommand("BACK");
        backButton.addActionListener(this);
        subPanel.add(backButton);
        panel.add(subPanel, BorderLayout.NORTH);
        
        //GRAPHIC WINDOW
        //much stealing here from Core Java 2, vol. 1 p.458
        subPanel = new JPanel();
        subPanel.setLayout(new BorderLayout());
        //subPanel.setBorder(BorderFactory.createEtchedBorder());
        drawPanel = new MousePanel(myControl, thingCollection);
        drawPanel.setBackground(Color.white);
        subPanel.add(drawPanel);
        panel.add(subPanel, BorderLayout.CENTER);
        
        /*-----------------*/
        contentPane.add(panel);
        addComponentListener(new ComponentAdapter(){
            public void componentResized(ComponentEvent evt){
                setVisibleAmounts();
            }
        });
        
    }
    
    public void setVisibleAmounts(){
        Dimension d = drawPanel.getSize();
        drawPanel.setSize(d);
    }
    
    public void actionPerformed(ActionEvent e){
        String cmd = e.getActionCommand();
        if (cmd == "CLEARPATH"){
            drawPanel.path = new Vector();
            drawPanel.repaint();
        }
        if ((drawPanel.path.size()>0)&&(cmd == "BACK")){
            int secondLast = drawPanel.path.size()-2;
            int f = ((Integer)(drawPanel.path.elementAt(secondLast))).intValue();
            setFocused(f);
        }
    }
/*            int in = ((Integer)(path.elementAt(0))).intValue();
            int cx = ((annotatedThing)(thingCollection.elementAt(in))).locX;
            int cy = ((annotatedThing)(thingCollection.elementAt(in))).locY;
            if (in == focused){
                cx = originX;
                cy = originY;
            }
 */
    public void setFocused(int findex){ // called from main
        focused = findex;
        drawPanel.changeFocus(findex);
        drawPanel.updateUI();
    }
    
}

class annotatedThing {
    Thing thing;
    int locX;
    int locY;
    int radius;
    boolean focused;
    boolean onPath;
    boolean selected;
    boolean visible;
    int xth;
    
    public annotatedThing(){
        System.err.println("Bogus default constructor call to annotatedThing");
    }
    
    public annotatedThing(Thing thing, int locX, int locY, int radius, boolean focused, boolean onPath, boolean selected, boolean visible){
        this.thing = thing;
        this.locX = locX;
        this.locY = locY;
        this.radius = radius;
        this.focused = focused;
        this.onPath = onPath;
        this.selected = selected;
        this.visible = visible;
        this.xth = 0;
    }
}

class MousePanel extends JPanel /*implements MouseInputListener*/ {
    
    private int dx;
    private int dy;
    public int MAX_X = 600;
    public int MAX_Y = 400;
    private Vector thingCollection;
    private int focused;
    private final sbb main;
    public Vector path;
    
    public MousePanel(sbb main, Vector v){
        this.main = main;
        thingCollection = v;
        focused = 0;
        path = new Vector();
        addMouseListener(new MouseInputAdapter() {
            public void mouseClicked(MouseEvent evt){
                int x = evt.getX() + dx;
                int y = evt.getY() + dy;
                System.err.println("Click in browser: (" + x + ", " + y + ")");
                int i = find(x,y);
                if (i > -1){
                    //found something. Now:
                    if (evt.getClickCount() > 1){ //doubleclick
                        //change focused item
                        //remember to tell sbb about it
                        //in my dreams: animate transition to new situation
                        changeFocus(i);
                    }
                }
            }
        });
        this.setToolTipText(".");
    }
    
    public void translate(int x, int y){
        dx = x;
        dy = y;
        repaint();
    }
    
    public void paintComponent(Graphics g){
        super.paintComponent(g);
        g.translate(-dx, -dy);
        drawEverything(g);
    }
    
    public int find(int x, int y){
        for(int i = 0; i < thingCollection.size(); i++){
            if (((annotatedThing)(thingCollection.elementAt(i))).visible){
                int rx = x - ((annotatedThing)(thingCollection.elementAt(i))).locX;
                int ry = y - ((annotatedThing)(thingCollection.elementAt(i))).locY;
                int rad2 = ((annotatedThing)(thingCollection.elementAt(i))).radius;
                rad2 *= rad2;
                if((rx * rx + ry * ry) <= rad2){
                    return i;
                }
            }
        }
        return -1;
    }
    
    public String getToolTipText(MouseEvent e){
        int index = find(e.getX()+dx, e.getY()+dy);
        if (index == -1){
            return "Hover over an object to view its description.";
        }else{
            return ((annotatedThing)(thingCollection.elementAt(index))).thing.toHTML();
        }
    }
    
    
    public void changeFocus(int f){
        ((annotatedThing)(thingCollection.elementAt(focused))).focused = false;
        focused = f;
        main.changeFocusFromBrowser(f);
        ((annotatedThing)(thingCollection.elementAt(focused))).focused = true;
        if (focused != 0)
            ((annotatedThing)(thingCollection.elementAt(focused))).onPath = true;
        path.addElement(new Integer(focused));
        this.repaint();
    }
    
    int dims;
    
    public void drawEverything(Graphics g){
        Dimension d = this.getSize();
        int focusRadius = 5;
        int originX = (int)(d.getWidth()/2);
        int originY = (int)(d.getHeight()/2);
        ((annotatedThing)(thingCollection.elementAt(focused))).locX = originX;
        ((annotatedThing)(thingCollection.elementAt(focused))).locY = originY;
        Vector weightVector = calculateWeights();
        //     System.out.println("Draw w("+weightVector.size()+") thingCollection("+thingCollection.size()+")");
        double t = 1-(main.threshold.getValue() / 100.0);
        double max = -1000;
/*        for (int i = 0; i < weightVector.size(); i++){
            double s = ((Double)(weightVector.elementAt(i))).doubleValue();
            if (s > max) max = s;
            if (s < 0) s = 0;
        }*/
        int toDraw = 0;
        for (int i = 0; i < thingCollection.size(); i++){ // ##/thingCollection/weightVector
            double temp;
            if (weightVector.elementAt(i)!=null){
                temp = (((Double)(weightVector.elementAt(i))).doubleValue() / dims); //max
            }else{
                temp=1.0/dims; //max
            }
            //System.out.println("*"+temp);
            //double temp = Math.abs(Math.sin(i)); //debug
            if (temp <= t){
                ((annotatedThing)(thingCollection.elementAt(i))).visible=true;
                ((annotatedThing)(thingCollection.elementAt(i))).xth=toDraw;
                toDraw++;
            }else{
                ((annotatedThing)(thingCollection.elementAt(i))).visible=false;
            }
            weightVector.setElementAt(new Double(temp/t), i);
        }
        for (int i = 0; i < thingCollection.size(); i++){
            if ((i != focused) && (((annotatedThing)(thingCollection.elementAt(i))).visible)){
                drawObj(g, originX, originY, i, ((Double)(weightVector.elementAt(i))).doubleValue(), toDraw, focusRadius);
            }
        }
        // focused object
        g.setColor(Color.red);
        if (focused == 0) // prototype
            g.setColor(Color.yellow);
        g.fillOval(originX - focusRadius, originY - focusRadius, 2*focusRadius, 2*focusRadius);
        g.setColor(Color.black);
        g.drawOval(originX - focusRadius, originY - focusRadius, 2*focusRadius, 2*focusRadius);
        //connect the dots on the path
        if (path.size() > 1){
            g.setColor(Color.blue.brighter().brighter());
            int in = ((Integer)(path.elementAt(0))).intValue();
            int cx = ((annotatedThing)(thingCollection.elementAt(in))).locX;
            int cy = ((annotatedThing)(thingCollection.elementAt(in))).locY;
            if (in == focused){
                cx = originX;
                cy = originY;
            }
            int px=0, py=0;
            for (int i = 1; i < path.size(); i++){
                px = cx; py = cy;
                in = ((Integer)(path.elementAt(i))).intValue();
                cx = ((annotatedThing)(thingCollection.elementAt(in))).locX;
                cy = ((annotatedThing)(thingCollection.elementAt(in))).locY;
                if (in == focused){
                    cx = originX;
                    cy = originY;
                }
                if (!((annotatedThing)(thingCollection.elementAt(in))).visible){
                    g.setColor(Color.lightGray);
                    g.drawOval(cx-3, cy-3, 6, 6);
                    g.setColor(Color.blue.brighter().brighter());
                }
                g.drawLine(px,py,cx,cy);
            }
        }
    }
    
    private void drawObj(Graphics g, int x, int y, int index, double score, int total, int focusRadius){
        int maxRadius;
        int h = (int)(getSize().getHeight());
        int panelWidth = (int)(getSize().getWidth());
        maxRadius = (int)(Math.min(h, panelWidth)*0.45);
        int radius = 2;
        annotatedThing obj = (annotatedThing)(thingCollection.elementAt(index));
        double angle = ((double)(obj.xth)/total)*2*Math.PI;
        g.setColor(Color.gray);
        int nx = (int)((((double)maxRadius * score) + focusRadius + radius) * Math.cos(angle)) + x;
        int ny = (int)((((double)maxRadius * score) + focusRadius + radius) * Math.sin(angle)) + y;
        obj.locX = nx;
        obj.locY = ny;
        obj.radius=radius;
        thingCollection.setElementAt(obj, index);
        g.setColor(Color.black);
        if (obj.onPath) g.setColor(Color.green);
        g.drawOval(nx - radius, ny-radius, 2*radius, 2*radius);
        //  System.out.println("ObjIdx "+index+" score "+score+" total "+total+ " Loc ("+(nx-x)+","+(ny-y)+") real ("+nx+","+ny+")" );
    }
    
    private Vector calculateWeights(){
        Vector weightVector = new Vector();
        weightVector.setSize(Thing.dimensionNames.length);
        Vector resultVector = new Vector();
        resultVector.setSize(thingCollection.size()+1); // ## maybe because of prototype...
        int wsize=0;
        int i;
        dims = 0;
        for (i = 0; i < Thing.dimensionNames.length; i++){
            Vector v = new Vector();
            if (
            !(
            ((JTextField)(main.protoVector.elementAt(i))).getText().equals("") ||
            ((JTextField)(main.protoVector.elementAt(i))).getText().equals("0")
            )
            &&
            (((JSlider)(main.sliderVector.elementAt(i))).getValue()!=0)
            ){
                dims++;
                v = ThingComparer.compareToAll(((annotatedThing)(thingCollection.elementAt(focused))).thing, main.tv, i, Thing.compareMethod[i]);
                //           System.out.println(Thing.dimensionNames[i]+" ["+v.size()+"] method "+ThingComparer.comparisons[Thing.compareMethod[i]]);
            }
            weightVector.setElementAt(v,i);
            if (wsize<v.size()) wsize = v.size();
        }
        //System.out.println("Compared "+wsize+" records on "+dims+" dimensions");
        
        for(int n=0; n<wsize; n++){
            double score=0;
            for (int k=0; k < Thing.dimensionNames.length; k++){
                Vector vk = (Vector)(weightVector.elementAt(k));
                if(vk.size() == 0) continue;
                double g = ((Double)(vk.elementAt(n))).doubleValue();
                g *= ((JSlider)(main.sliderVector.elementAt(k))).getValue() / 100.0;
                score += g;
            }
            resultVector.setElementAt(new Double(score), n);
        }
        return resultVector;
    }
}
