/*
 * Thing.java
 *
 * Created on March 11, 2003, 3:35 PM
 */

package dataWrangler;
import java.util.*;
/**
 *
 * @author  rod
 */
public class Thing {
    public static final int PATH = 0;
    public static final int FILENAME = 1;
    public static final int EXTENSION = 2;
    public static final int HIT_COUNT = 3;
    public static final int FILE_SIZE = 4;
    public static final int UID = 5;
    public static final int GID = 6;
    public static final int MTIME = 7;
    public static final int CTIME = 8;
    public static final int TITLE = 9;
    
    public String getByDimension(int dim){
        switch(dim){
            case PATH: return path;
            case FILENAME: return filename;
            case EXTENSION: return extension;
            case HIT_COUNT: return Integer.toString(hitCount);
            case FILE_SIZE: return Integer.toString(size);
            case UID: return Integer.toString(uid);
            case GID: return Integer.toString(gid);
            case MTIME: return Long.toString(mtime);
            case CTIME: return Long.toString(ctime);
            case TITLE: return title;
        }
        return "ERROR";
    }
    
    public void setByDimension(int dim, String s){
        if (s==null) return;
        if (Thing.dimensionTypes[dim] == ThingComparer.INT || Thing.dimensionTypes[dim] == ThingComparer.LONG)
            s = "0";
        switch(dim){
            case PATH: path = s; break;
            case FILENAME: filename = s; break;
            case EXTENSION: extension = s; break;
            case HIT_COUNT: hitCount = Integer.parseInt(s); break;
            case FILE_SIZE: size = Integer.parseInt(s); break;
            case UID: uid = Integer.parseInt(s); break;
            case GID: gid = Integer.parseInt(s); break;
            case MTIME: mtime = Long.parseLong(s); break;
            case CTIME: ctime = Long.parseLong(s); break;
            case TITLE: title = s;
        }
    }
    
    public static String[] dimensionNames = {
        "Path",
        "Filename",
        "Extension",
        "Hit Count", 
        "File Size", 
        "uid", 
        "gid", 
        "Modified Time",
        "Creation Time",
        "Title"
    };
    
    public static int[] dimensionTypes = {
        ThingComparer.STRING,
        ThingComparer.STRING,
        ThingComparer.STRING,
        ThingComparer.INT,
        ThingComparer.INT,
        ThingComparer.INT,
        ThingComparer.INT,
        ThingComparer.LONG,
        ThingComparer.LONG,
        ThingComparer.STRING
    };
    
    
    public static int[] compareMethod = {
        ThingComparer.STRING_COMPARE_FIRST,
        ThingComparer.STRING_COMPARE_CONTAINS,
        ThingComparer.STRING_COMPARE_EQUALS,
        ThingComparer.NUM_COMPARE_GAUSSIAN,
        ThingComparer.NUM_COMPARE_ABS_DIFF,
        ThingComparer.NUM_COMPARE_EQUAL,
        ThingComparer.NUM_COMPARE_EQUAL,
        ThingComparer.NUM_COMPARE_GAUSSIAN,
        ThingComparer.NUM_COMPARE_GAUSSIAN,
        ThingComparer.STRING_COMPARE_SHARED_WORDS
    };
    
    public String path;
    public String filename;
    public String extension;
    public int hitCount;
    public int size; 
    public int uid;
    public int gid;
    public long mtime;
    public long ctime;
    public String title;
    
    /** Creates a new instance of Thing */
    public Thing() {
        path = null;
        filename = null;
        extension = null;
        hitCount = 0;
        size = 0; 
        uid = 0;
        gid = 0;
        mtime = 0;
        ctime = 0;
        title = null;
    }
    
    public String toHTML(){
        String out = "<HTML><BODY>"+path+filename+"<BR> ext:"+extension+" hits: "+hitCount+" size: "+size;
        out += " uid: "+uid+" gid: "+gid+"<BR> modified: "+(new Date(mtime)).toString()+"<BR> created: "+(new Date(ctime)).toString();
        if(title != null){
        out += "<BR> Title: "+title+"</BODY></HTML>";
        }
        return out;
    }

    public String toString(){
        String out = path+filename+"\n ext:"+extension+" hits: "+hitCount+" size: "+size;
        out += " uid: "+uid+" gid: "+gid+"\n modified: "+(new Date(mtime)).toString()+"\n created: "+(new Date(ctime)).toString();
        if(title != null){
        out += "\n Title: "+title;
        }
        return out;
    }
}
